% lab11_ex_analytic.m
% using Hilbert transform for computation of complex-value analytic signal
  clear all; close all;

  fs = 8000;                        % sampling frequency
  Nx = 8000;                        % number of samples
  dt = 1/fs; t = dt*(0:Nx-1);       % sampling period, sampling moments
  fc = 1000; kf = 200; fm = 10;     % carrier, modulation index, modulation freq 
  x = cos(2*pi*(fc*t + kf/(2*pi*fm)*sin(2*pi*fm*t)));  % SFM signal
  xa = hilbert( x );                % analytic signal, positive frequencies
  xp = x + j*imag(xa);              % analytic signal, the same as above
  xm = x - j*imag(xa);              % negative frequencies
  error = max(abs(xa - xp)),        % value close to zero
% Spectra
  X  = fftshift( abs(fft(x))  )/Nx; % for original signal 
  Xa = fftshift( abs(fft(xa)) )/Nx; % for analytic signal with positive freqs only
  Xm = fftshift( abs(fft(xm)) )/Nx; % for analytic signal with negative freqs only
% Figures  
  f0 = fs/Nx; f=f0*(-Nx/2:Nx/2-1);
  subplot(311); plot(f,X ); title('|X(f)|');  xlabel('(Hz)'); grid;
  subplot(312); plot(f,Xa); title('|Xa(f)|'); xlabel('(Hz)'); grid;
  subplot(313); plot(f,Xm); title('|Xm(f)|'); xlabel('(Hz)'); grid;